#!/usr/bin/python
"""Eep RDF API: Built-Ins Test Suite"""

__author__ = 'Sean B. Palmer'
__license__ = 'Copyright (C) 2002 Sean B. Palmer. GNU GPL 2'

import cwmclone, n3
from eep3 import api, query, ntuples

def test(): 
   testFiles = [
"""{ ?x ?y ?z .
 ?x <http://www.w3.org/2000/10/swap/log#notEqualTo> ?z } => 
 { ?x <#notEqualTo> ?z } .
<#p> <#q> <#p> .""", 

"""{ ?x ?y ?z . 
  ?x <http://www.w3.org/2000/10/swap/log#uri> ?p } => { ?x <#uri> ?p } .
<#p> <#q> <#r> .
<#x> <#y> <#z> .""", 

"""{ ?x ?y ?z .
 ?x <http://www.w3.org/2000/10/swap/string#notEqualTo> ?z } => 
 { ?x <#notEqualTo> ?z } .
"p" <#q> "r" .
<#p> <#q> <#p> .
"p" <#q> "p" .
"x" _:y "z" .""", 

# """{ ?x <#type> <#Target> . 
#    ?x <http://example.org/#sha512> ?z } => 
#  { ?x <#sha512> ?z } .
# "blargh" <#type> <#Target> .""", 

# """{ ?x <#type> <#Target> . 
#    ?x <http://www.w3.org/2000/10/swap/log#content> ?z . } => 
#  { ?x <#resolvesTo> ?z . } .
# <http://infomesh.net/2001/10/spew.txt> <#type> <#Target> .""", 

"""{ ?x <#y> ?z . 
     ?x <http://www.w3.org/2000/10/swap/string#startsWith> ?z } => 
 { ?x <#startsWith> ?z } .
"blargh" <#y> "bla" .
"blargh" <#y> "xyz" .""", 

"""{ ?x <#y> ?z . 
     ?x <http://www.w3.org/2000/10/swap/log#uri> ?p .
     ?p <http://www.w3.org/2000/10/swap/string#startsWith> ?z } => 
 { ?x <#uriStartsWith> ?z } .
<blargh> <#y> "bla" .
<blargh> <#y> "xyz" .""", 

"""{ ?x a <#Target>; <http://www.w3.org/2000/10/swap/string#concat> ?y } => 
 { ?y a <#Result> } . ("x" "y" "z") a <#Target> .""", 

"""{ <#p> <#q> ?r .
   ("p" "q" ?r) <http://www.w3.org/2000/10/swap/string#concat> ?y } => 
 { ?y a <#Result> } . <#p> <#q> "r" .""", 

"""<http://blargh.org/> dc:title "blargh"; 
   rdfs:seeAlso <http://example.org/> . 

{ ("<a href=\\"" ?uri "\\">" ?title "</a>") string:concat ?output . 
   ?x dc:title ?title; rdfs:seeAlso ?also . ?also log:uri ?uri } => 
   { ?x <#htmlStuff> ?output; <#rdfsU> ?uri } ."""
]

   import n3s
   for testFile in testFiles: 
      print testFile
      testFile = n3s.process(testFile)
      store = n3.parse(testFile, '')
      print n3.serialize(cwmclone.filter(store))

if __name__=="__main__": 
   test()